var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  breakPoints: () => breakPoints,
  checkIsCSSLength: () => checkIsCSSLength,
  fromEntries: () => fromEntries,
  getSafeGutter: () => getSafeGutter,
  getSizeValue: () => getSizeValue,
  getSpacingValue: () => getSpacingValue,
  mergeBreakpoints: () => mergeBreakpoints,
  sizes: () => sizes,
  spacing: () => spacing,
  uid: () => uid,
  validateGutter: () => validateGutter
});

// src/breakpoints.ts
var smallOnly = 639;
var mediumOnly = [640, 1023];
var largeOnly = [1024, 1199];
var xlargeOnly = [1200, 1439];
var medium = 1023;
var large = 1199;
var xlarge = 1439;
var xxlarge = 1920;
var breakPoints = {
  smallOnly,
  mediumOnly,
  largeOnly,
  xlargeOnly,
  medium,
  large,
  xlarge,
  xxlarge
};
var mergeBreakpoints = (newBreakPoints = {}) => __spreadValues(__spreadValues({}, breakPoints), newBreakPoints);

// src/css.ts
function checkIsCSSLength(string_) {
  if (typeof string_ !== "string") {
    return false;
  }
  return [
    /^\d{0,10000}\.?\d{1,10000}(vmin|vmax|vh|vw|%|ch|ex|em|rem|in|cm|mm|pt|pc|px)$/,
    /^var\(--\D{1,100}\)$/
  ].some((regex) => regex.test(string_));
}

// src/utils.ts
function fromEntries(entries) {
  return Object.fromEntries(entries.map(([key, value]) => [key, value]));
}

// src/spacing.ts
var none = "0px";
var xxs = "0.0625rem";
var xs = "0.125rem";
var sm = "0.25rem";
var md = "0.5rem";
var lg = "0.75rem";
var xl = "1rem";
var xxl = "1.5rem";
var xxxl = "2rem";
var xxxxl = "3rem";
var xxxxxl = "4rem";
var spacing = {
  none,
  xxs,
  xs,
  sm,
  md,
  lg,
  xl,
  xxl,
  xxxl,
  xxxxl,
  xxxxxl
};
var getSpacingValue = (theme, spacingKey) => {
  var _a, _b;
  const maybeSpaceingOrDefault = (_b = (_a = theme.space) != null ? _a : theme.spacing) != null ? _b : spacing;
  const safeSpacings = fromEntries(Object.entries(maybeSpaceingOrDefault).map(([spaceKey, value]) => [
    spaceKey,
    typeof value === "number" ? `${value}px` : value
  ]));
  const spacingValue = safeSpacings[spacingKey];
  const isCSSLength = checkIsCSSLength(spacingValue);
  return isCSSLength ? spacingValue : void 0;
};

// src/gutters.ts
function getSafeGutter(theme, gutter) {
  if (typeof gutter === "number" && gutter > 0) {
    return `${gutter}px`;
  }
  const isCSSLength = checkIsCSSLength(gutter);
  if (isCSSLength) {
    return gutter;
  }
  return gutter !== void 0 ? getSpacingValue(theme, gutter) : void 0;
}
function validateGutter({ gutter }, propName) {
  if (gutter === void 0) {
    return;
  }
  const isValid = typeof gutter === "number" || typeof gutter === "string";
  if (isValid) {
    return;
  }
  console.error(`${propName} needs to be a number, CSSLength or SizesOptions`);
}

// src/sizing.ts
var xxsmall = 159;
var xsmall = 319;
var small = 639;
var medium2 = 1023;
var large2 = 1199;
var xlarge2 = 1439;
var xxlarge2 = 1920;
var sizes = {
  xxsmall: `${xxsmall}px`,
  xsmall: `${xsmall}px`,
  small: `${small}px`,
  medium: `${medium2}px`,
  large: `${large2}px`,
  xlarge: `${xlarge2}px`,
  xxlarge: `${xxlarge2}px`
};
var getSizeValue = (theme, sizeKey) => {
  var _a;
  if (typeof sizeKey === "number" || sizeKey === void 0) {
    return void 0;
  }
  const maybeSizesOrDefault = (_a = theme.sizes) != null ? _a : sizes;
  const safeSizes = fromEntries(Object.entries(maybeSizesOrDefault).map(([sizeKey2, value]) => [
    sizeKey2,
    typeof value === "number" ? `${value}px` : value
  ]));
  return safeSizes[sizeKey];
};

// src/uid.ts
var counters = /* @__PURE__ */ new Map();
function uid(prefix = "") {
  var _a;
  if (!counters.has(prefix)) {
    counters.set(prefix, 0);
  }
  const counter = (_a = counters.get(prefix)) != null ? _a : 0;
  counters.set(prefix, counter + 1);
  return ["chisel", prefix, counter + 1].filter(Boolean).join("-");
}
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  breakPoints,
  checkIsCSSLength,
  fromEntries,
  getSafeGutter,
  getSizeValue,
  getSpacingValue,
  mergeBreakpoints,
  sizes,
  spacing,
  uid,
  validateGutter
});
